/*

        
===============================================================

      ,   
    PCM   .  
       
ACM,       RIFF Wave  
 MMIO.

*/





#pragma warning (disable: 4115 4201 4214 4514)


#if _DEBUG

  #pragma warning (disable: 4505)

#endif


#define STRICT

#include <windows.h>            //   Windows
#include <commctrl.h>           //    

#include <mmreg.h>              //   

#include <msacm.h>              //  ACM

#include <stdlib.h>             //    C/C++
#include <limits.h>             //   


#include "resource.h"           //  







//
// #########################################################################
//
//  
//
// #########################################################################
//





#define DefSampleRate 44100     //  
#define DefBitsPerSample 16     //  
#define DefChannels 2           //  

#define WaveBufferMS 500        //     
#define WaveBuffers 4           //  

#define SrcBufferMS 100         //     





//
// #########################################################################
//
// 
// 
// #########################################################################
//





enum {                          //   

  WMU_StopCompleted = WM_USER + 1024, //  

};





//
// #########################################################################
//
// 
// 
// #########################################################################
//





#ifdef _DEBUG

  #include <stdio.h>

  #define Debug DebugPrintF /*       */ 

#else

  #define Debug /##/

#endif


#define UNREF(x) (void)(x)





//
// #########################################################################
//
// 
// 
// #########################################################################
//




//
//  WaveFormat -   
//  WAVEFORMATEX    
//    .
//
//    C++  WaveFormat
//   ,    WAVEFORMATEX.
//

struct WaveFormat : public tWAVEFORMATEX {

  BYTE Ext [128];               //   

};





//
// #########################################################################
//
// 
// 
// #########################################################################
//





static HINSTANCE GlobalInst;    //   





//
// #########################################################################
//
// 
//
// #########################################################################
//


HWAVEIN In;                   //   

HACMSTREAM Stream;            //   

HMMIO File;                   //   

WAVEFORMATEX SrcFmt;          //     (PCM)
WaveFormat DstFmt;            //     ()

UINT SampleRate = DefSampleRate;       //  
UINT BitsPerSample = DefBitsPerSample; //  
UINT Channels = DefChannels;           //  

UINT BytesPerSample;          //    

UINT WaveBufferSize;          //     PCM  

UINT AllocatedBuffers;        //   
UINT InBuffers;               //     Wave In

UINT SrcBufferSize;           //     
UINT DstBufferSize;           //      

BYTE *SrcBuffer;              //     
BYTE *DstBuffer;              //     

UINT SrcBytes;                //     
UINT ConvertedSamples;        //   

DWORD ConvertFlags;           //   ACM

MMCKINFO RiffChunk;           //   RIFF  
MMCKINFO FactChunk;           //   fact  
MMCKINFO DataChunk;           //   data  

DWORD Flags;                  //  

  #define SF_Running 1        //  
  #define SF_StopReq 2        //  


HANDLE WorkerThreadHandle;    //   
DWORD WorkerThreadId;         //   



HWND DlgWin;                  //   

DWORD DefPrioClass;           //     

DWORD StartTime;              //    





//
// #########################################################################
//
// 
//
// #########################################################################
//





//
//   
// =======================
//

#ifdef _DEBUG

static void DebugPrintF (char *Format, ...) {

  char Str [256];
  va_list Args;
  int Len;

  sprintf (
    Str,
    "%06u: %n",
    (timeGetTime () - StartTime) % 1000000,
    &Len
  );

  va_start (Args, Format);
  vsprintf (Str + Len, Format, Args);
  va_end (Args);
  strcat (Str, "\r\n");
  OutputDebugString (Str);

}

#endif





//
//    
// ==========================
//

void Error (char *Text) {

  MessageBox (NULL, Text, "Error", MB_ICONERROR | MB_OK);

}





//
//      
// ======================================================
//

LONG DlgMsg (int Id, UINT Msg, LPARAM lp, WPARAM wp) {

  return SendDlgItemMessage (DlgWin, Id, Msg, lp, wp);

}




//
// /    
// ================================================
//
//    
//

void EnableControls (BOOL Enable, ...) {

  va_list Ctrls;

  va_start (Ctrls, Enable);

  for (;;) {

    UINT Ctrl = va_arg (Ctrls, UINT);

    if (!Ctrl) {

      break;

    }

    EnableWindow (GetDlgItem (DlgWin, Ctrl), Enable);

  }

  va_end (Ctrls);

}





//
//    ComboBox 
// ====================================
//

void AddStringToCB (UINT Ctl, char *Str) {

  DlgMsg (Ctl,  CB_ADDSTRING,  0, (LPARAM)Str);

}





//
//     
// ====================================
//

void SetNumToCtl (UINT Ctl, UINT Num) {

  char Str [20];

  ultoa (Num, Str, 10);

  DlgMsg (Ctl,  WM_SETTEXT,  0, (LPARAM)Str);

}





//
//      
// ==================================================
//
//  UINT_MAX   
//

UINT GetNumFromCtl (UINT Ctl) {

  char Str [20];
  char *End;
  UINT Num;

  DlgMsg (Ctl,  WM_GETTEXT,  sizeof (Str), (LPARAM)Str);

  Num = strtoul (Str, &End, 10);

  if (*End && !isspace (*End)) {

    Num = UINT_MAX;

  }

  return Num;

}





//
//    PCM
// ================================
//

void SetPcmFormat (UINT SampleRate, UINT Channels, UINT BitsPerSample) {

  BytesPerSample = (BitsPerSample + 7) / 8;

  SrcFmt.wFormatTag = WAVE_FORMAT_PCM;
  SrcFmt.nChannels = (WORD)Channels;
  SrcFmt.wBitsPerSample = (WORD)BitsPerSample;
  SrcFmt.nBlockAlign = (WORD)(Channels * BytesPerSample);
  SrcFmt.nSamplesPerSec = SampleRate;
  SrcFmt.nAvgBytesPerSec = SrcFmt.nSamplesPerSec * SrcFmt.nBlockAlign;
  SrcFmt.cbSize = 0;

  if (!DstFmt.wFormatTag) {

    memcpy (&DstFmt, &SrcFmt, min (sizeof (SrcFmt), sizeof (DstFmt)));

  }

}





//
//     
// =================================
//
//     
//

BOOL ReadAllParams (void) {

  BOOL Res = TRUE;

  SampleRate = GetNumFromCtl (IDC_SampleRate);
  BitsPerSample = GetNumFromCtl (IDC_BitsPerSample);
  Channels = (DlgMsg (IDC_Stereo, BM_GETCHECK, 0, 0) == BST_CHECKED) + 1;

  if (!SampleRate || SampleRate > 1000000) {

    Error ("  ");

    Res = FALSE;

  }
  
  if (BitsPerSample < 8 || BitsPerSample > 32) {

    Error ("  ");

    Res = FALSE;

  }
  
  if (Res) {

    SetPcmFormat (SampleRate, Channels, BitsPerSample);

  }

  return Res;

}





//
//   
// ==========================
//

void StopDevices (void) {

  Flags |= SF_StopReq;

  waveInReset (In);

}





//
//  
// =====================
//

void Cleanup (void) {

  if (In) {

    waveInReset (In);

  }

  if (SrcBuffer) {

    GlobalFree (SrcBuffer);
    SrcBuffer = NULL;

  }

  if (DstBuffer) {

    GlobalFree (DstBuffer);
    DstBuffer = NULL;

  }

}





//
//  
// ====================
//

void CloseDevices (void) {

  if (In) {

    waveInClose (In);

    In = NULL;

  }

  if (Stream) {

    acmStreamClose (Stream, 0);

    Stream = NULL;

  }

  if (File) {

    mmioClose (File, 0);

    File = NULL;

  }

}





//
//   
// =============================
//


void ReleaseBuffer (WAVEHDR *Hdr) {

  GlobalFree ((HGLOBAL)Hdr->lpData);
  LocalFree ((HLOCAL)Hdr);

  if (!--AllocatedBuffers) {    //    

    //
    //      
    //

    PostThreadMessage (WorkerThreadId, WM_QUIT, 0, 0);

  }

}





//
//     
// =======================================
//
//   
//

BOOL CreateFile (void) {

  MMRESULT Res;
  UINT Written;

  ACMFORMATTAGDETAILS TagDet;   //    

  memset (&TagDet, 0, sizeof (TagDet));

  TagDet.cbStruct = sizeof (TagDet);
  TagDet.dwFormatTag = DstFmt.wFormatTag; //   


  //
  //       
  //

  Res = acmFormatTagDetails (
    NULL,
    &TagDet,
    ACM_FORMATTAGDETAILSF_FORMATTAG
  );

  if (Res != MMSYSERR_NOERROR) {

    Error ("    ");

    return FALSE;

  }


  //
  //    
  //

  char FileName [_MAX_PATH];

  DlgMsg (IDC_FileName, WM_GETTEXT, sizeof (FileName) - 4, (LPARAM)FileName);

  strcat (FileName, ".wav");


  //
  //  
  //

  File = mmioOpen (
    FileName,
    NULL,
    MMIO_CREATE | MMIO_READWRITE | MMIO_ALLOCBUF | MMIO_DENYWRITE
  );

  if (!File) {

    Error ("  ");

    return FALSE;

  }


  //
  //    
  //

  MMCKINFO FmtChunk;

  memset (&RiffChunk, 0, sizeof (RiffChunk));
  memset (&FmtChunk, 0, sizeof (FmtChunk));
  memset (&FactChunk, 0, sizeof (FactChunk));
  memset (&DataChunk, 0, sizeof (DataChunk));

  RiffChunk.fccType = mmioFOURCC ('W', 'A', 'V', 'E');

  Res = 0;
  
  Res |= mmioCreateChunk (File, &RiffChunk, MMIO_CREATERIFF);

  FmtChunk.ckid = mmioFOURCC ('f', 'm', 't', ' ');
  FmtChunk.cksize = TagDet.cbFormatSize; //    

  Res |= mmioCreateChunk (File, &FmtChunk, 0);

  Written = mmioWrite (File, (char *)&DstFmt, FmtChunk.cksize);

  Res |= Written - FmtChunk.cksize;

  Res |= mmioAscend (File, &FmtChunk, 0);


  //
  // ,   PCM,   fact
  //

  if (DstFmt.wFormatTag != WAVE_FORMAT_PCM) {

    FactChunk.ckid = mmioFOURCC ('f', 'a', 'c', 't');
    FactChunk.cksize = 4;

    Res |= mmioCreateChunk (File, &FactChunk, 0);

    Written = mmioWrite (File, (char *)&ConvertedSamples, 4);

    Res |= Written - 4;

  }

  DataChunk.ckid = mmioFOURCC ('d', 'a', 't', 'a');
  DataChunk.cksize = 0;

  Res |= mmioCreateChunk (File, &DataChunk, 0);


  //
  //    ,  Res  
  //

  if (Res) {

    Error ("   ");

    return FALSE;

  }

  return TRUE;

}





//
//     
// ====================================
//


int OpenDevices (void) {

  MMRESULT Res;
  
  In = NULL;
  AllocatedBuffers = 0;


  //
  //  
  //

  SrcBytes = 0;
  ConvertedSamples = 0;

  ConvertFlags = ACM_STREAMCONVERTF_START | ACM_STREAMCONVERTF_BLOCKALIGN;


  //
  //      
  //

  int  DevN = DlgMsg (IDC_WaveIn, CB_GETCURSEL, 0, 0);


  //
  //    ,   
  //

  Res = waveInOpen (
    &In,
    DevN - 1,
    &SrcFmt,
    (DWORD)WorkerThreadId,
    0,
    CALLBACK_THREAD
  );


  if (Res != MMSYSERR_NOERROR) {

    //
    //    
    //

    Error ("   ");

    return FALSE;

  }


  //
  //      
  //

  WaveBufferSize = (SrcFmt.nSamplesPerSec * WaveBufferMS / WaveBuffers + 500) / 1000;

  if (!WaveBufferSize) {

    WaveBufferSize++;

  }


  //
  //      
  //

  WaveBufferSize *= SrcFmt.nBlockAlign;


  Debug ("Wave buffer size - %u", WaveBufferSize);


  //
  //      ,   
  //     
  //

  for (int N = WaveBuffers; N > 0; N--) {

    char *Buf = (char *)GlobalAlloc (GMEM_FIXED, WaveBufferSize);
    WAVEHDR *Hdr = (WAVEHDR *)LocalAlloc (LMEM_FIXED, sizeof (*Hdr));

    if (Buf && Hdr) {

      //
      //   
      //

      Hdr->lpData = Buf;
      Hdr->dwBufferLength = WaveBufferSize;
      Hdr->dwFlags = 0;
      Hdr->dwLoops = 0;
      Hdr->dwUser = 0;


      //
      //    
      //

      waveInPrepareHeader (In, Hdr, sizeof (*Hdr));
      Res = waveInAddBuffer (In, Hdr, sizeof (*Hdr));

    }

    if (Buf && Hdr && Res == MMSYSERR_NOERROR) {

      AllocatedBuffers++;
      InBuffers++;

    } else {

      //
      // .   
      //

      if (Buf) {

        GlobalFree ((HGLOBAL)Buf);

      }

      if (Hdr) {

        LocalFree ((HLOCAL)Hdr);

      }

      if (!Hdr || !Buf) {

        Error ("    ");

      } else {

        Error ("    ");

      }

      return FALSE;

    }

  }


  //
  //   
  //

  Res = acmStreamOpen (&Stream, NULL, &SrcFmt, &DstFmt, NULL, 0, 0, 0);

  if (Res != MMSYSERR_NOERROR) {

    Error ("   ");

    return FALSE;

  }


  //
  //      
  //

  SrcBufferSize = (SrcFmt.nSamplesPerSec * SrcBufferMS + 500) / 1000;

  if (!SrcBufferSize) {

    SrcBufferSize++;

  }


  //
  //      
  //

  SrcBufferSize *= SrcFmt.nBlockAlign;


  Debug ("Source buffer size - %u", SrcBufferSize);


  //
  //     
  //

  SrcBuffer = (BYTE *)GlobalAlloc (GMEM_FIXED, SrcBufferSize);

  if (!SrcBuffer) {

    Error ("    ");

    return FALSE;

  }


  //
  //    
  //

  Res = acmStreamSize (
    Stream,
    SrcBufferSize,
    (DWORD *)&DstBufferSize,
    ACM_STREAMSIZEF_SOURCE
  );

  if (Res != MMSYSERR_NOERROR) {

    Error ("    ");

    return FALSE;

  }

  if (!DstBufferSize) {

    Error ("     ");

    return FALSE;

  }


  Debug ("Destination buffer size - %u", DstBufferSize);


  //
  //     
  //

  DstBuffer = (BYTE *)GlobalAlloc (GMEM_FIXED, DstBufferSize);

  if (!DstBuffer) {

    Error ("    ");

    return FALSE;

  }


  //
  //  
  //

  if (!CreateFile ()) {

    return FALSE;

  }


  return TRUE;

}





//
//    
// ====================================
//
//       
//
//     
//

BOOL CompressSrcBuffer (BOOL Last) {

  MMRESULT Res;


  //
  //    -    
  //

  if (!SrcBytes) {

    SrcBytes = SrcFmt.nBlockAlign;

    memset (SrcBuffer, (BytesPerSample > 1)? 0 : 0x80, SrcBytes);

  }


  //
  //   
  //

  ACMSTREAMHEADER AH;

  AH.cbStruct = sizeof (AH);
  AH.fdwStatus = 0;
  AH.pbSrc = SrcBuffer;
  AH.cbSrcLength = SrcBytes;
  AH.pbDst = DstBuffer;
  AH.cbDstLength = DstBufferSize;


  //
  //  
  //

  Res = acmStreamPrepareHeader (Stream, &AH, 0);

  if (Res != MMSYSERR_NOERROR) {

    StopDevices ();

    Error ("   ");

    return FALSE;

  }


  //
  //    -    
  //

  if (Last) {
  
    ConvertFlags &= ~ACM_STREAMCONVERTF_BLOCKALIGN;
    ConvertFlags |= ACM_STREAMCONVERTF_END;

  }


  //
  //  
  //

  Res = acmStreamConvert (Stream, &AH, ConvertFlags);

  ConvertFlags &= ~ACM_STREAMCONVERTF_START; //     

  if (Res != MMSYSERR_NOERROR) {

    StopDevices ();

    Error ("   ");

    return FALSE;

  }


  //
  //      - 
  //

  if (!AH.cbSrcLengthUsed && !AH.cbDstLengthUsed) {

    StopDevices ();

    Error ("   ");

    return FALSE;

  }


  //
  //  
  //

  acmStreamUnprepareHeader (Stream, &AH, 0);


  //
  //    
  //

  ConvertedSamples += AH.cbSrcLengthUsed / SrcFmt.nBlockAlign;

  //
  //      -   
  //

  if (AH.cbDstLengthUsed) {

    UINT FileWritten = mmioWrite (File, (char *)AH.pbDst, AH.cbDstLengthUsed);

    if (FileWritten != AH.cbDstLengthUsed) {

      StopDevices ();

      Error ("    ");

      return FALSE;

    }

  }


  //
  //     
  //

  SrcBytes -= AH.cbSrcLengthUsed;

  memmove (SrcBuffer, SrcBuffer + AH.cbSrcLengthUsed, SrcBytes);


  return TRUE;

}





//
//     
// ================================
//
//   
//

BOOL CompressBlock (

  BYTE *Data,                   //   
  UINT Size                     //   

) {

  //
  //    
  //

  while (Size) {


    //
    //       
    //

    UINT SrcAvail = SrcBufferSize - SrcBytes;

    SrcAvail = min (SrcAvail, Size); //   


    //
    //        
    //

    memcpy (SrcBuffer + SrcBytes, Data, SrcAvail);


    //
    //    
    //

    SrcBytes += SrcAvail;

    Data += SrcAvail;
    Size -= SrcAvail;


    //
    //     - 
    //

    if (SrcBytes == SrcBufferSize) {

      if (!CompressSrcBuffer (FALSE)) {

        return FALSE;

      }

    }

  }


  return TRUE;

}





//
//     
// ==================================
//
//   
//

BOOL FinishWriting (void) {

  MMRESULT Res = 0;
  UINT Written;

  Res |= mmioAscend (File, &DataChunk, 0);

  Res |= mmioAscend (File, &RiffChunk, 0);


  //
  // ,   PCM,   fact
  //

  if (DstFmt.wFormatTag != WAVE_FORMAT_PCM) {

    Res |= (mmioSeek (File, FactChunk.dwDataOffset, SEEK_SET) == -1);

    Written = mmioWrite (File, (char *)&ConvertedSamples, 4);

    Res |= Written - 4;

  }

  if (Res) {

    Error ("   ");

    return FALSE;

  }

  mmioClose (File, 0);

  Debug ("Samples written - %u", ConvertedSamples);

  return TRUE;

}





//
//  
// ==============
//

DWORD WINAPI WorkerThreadProc (void *Arg) {

  //
  //      
  //

  SetThreadPriority (GetCurrentThread (), THREAD_PRIORITY_TIME_CRITICAL);

  DWORD SamplesShownTime = timeGetTime ();

  MSG Msg;

  //
  //         WM_QUIT
  //    
  //

  while (GetMessage (&Msg, NULL, 0, 0) == TRUE) {

    switch (Msg.message) {





      //
      //     
      //

      case MM_WIM_DATA: {

        WAVEHDR *Hdr = (WAVEHDR *)Msg.lParam;

        MMRESULT Res;

        InBuffers--;


        //
        //      
        //

        CompressBlock ((BYTE *)Hdr->lpData, Hdr->dwBytesRecorded);


        if ((Flags & SF_Running) && !(Flags & SF_StopReq)) {

          //
          //    
          //

          Res = waveInAddBuffer (In, Hdr, sizeof (*Hdr));

          if (Res == MMSYSERR_NOERROR) {

            InBuffers++;

          } else {

            StopDevices ();

            Error ("    ");

            break;

          }

        } else {

          //
          //  
          //

          waveInUnprepareHeader (In, Hdr, sizeof (*Hdr));

          ReleaseBuffer (Hdr);

        }


        DWORD Time = timeGetTime ();

        if (SamplesShownTime - Time > 100) {

          SetNumToCtl (IDC_ConvertedSamples, ConvertedSamples);

          SamplesShownTime = Time;

        }


        break;

      }





    }

  }


  //
  //       -
  //

  if (Flags & SF_StopReq) {

    do {

      CompressSrcBuffer (TRUE); //  

    } while (SrcBytes);

    FinishWriting ();           //  

  }

  PostMessage (DlgWin, WMU_StopCompleted, 0, 0);

  return 0;

  UNREF (Arg);

}




//
//    
// =====================================
//

BOOL CALLBACK DialogProc (HWND Win, UINT Msg, WPARAM wp, LPARAM lp) {

  DlgWin = Win;

  switch (Msg) {





    //
    //   
    // ==============================
    //

    case WM_INITDIALOG: {

      int NumWaveDevs;
      int i;

      DefPrioClass = GetPriorityClass (GetCurrentProcess ());


      //
      //    ,   Wave Mapper
      //

      NumWaveDevs = waveInGetNumDevs ();
      
      for (i = 0; i < NumWaveDevs + 1; i++) {
        
        WAVEINCAPS DevCaps;

        waveInGetDevCaps (i - 1, &DevCaps, sizeof (DevCaps));
        DlgMsg (IDC_WaveIn,  CB_ADDSTRING,  0, (LPARAM)DevCaps.szPname);
        
      }

      DlgMsg (IDC_WaveIn, CB_SETCURSEL, 0, 0);


      //
      //      
      //

      AddStringToCB (IDC_SampleRate, "8000");
      AddStringToCB (IDC_SampleRate, "11025");
      AddStringToCB (IDC_SampleRate, "22050");
      AddStringToCB (IDC_SampleRate, "44100");

      AddStringToCB (IDC_BitsPerSample, "8");
      AddStringToCB (IDC_BitsPerSample, "16");


      //
      //  
      //

      SetNumToCtl (IDC_SampleRate, SampleRate);
      SetNumToCtl (IDC_BitsPerSample, BitsPerSample);

      DlgMsg (IDC_Stereo, BM_SETCHECK, BST_CHECKED, 0);

      return TRUE;

    }





    //
    //   Windows
    // ===========================
    //

    case WM_COMMAND: {

      UINT CtrlId = LOWORD (wp);
      UINT CtrlMsg = HIWORD (wp);
      
      switch (CtrlId) {
        

        //
        //     -     
        // =================================================================
        //

        case IDCANCEL: {

          if (!(Flags & SF_Running)) {

            EndDialog (DlgWin, 0);
            return TRUE;

          }

          break;

        }
        



        //
        //    
        // ============================
        //

        case IDC_FormatChoose: {

          ReadAllParams ();   //  
 
          ACMFORMATCHOOSE FC;

          memset (&FC, 0, sizeof (FC));

          FC.cbStruct = sizeof (FC);

          FC.fdwStyle = ACMFORMATCHOOSE_STYLEF_INITTOWFXSTRUCT;

          FC.hwndOwner = DlgWin;
          FC.pwfx = &DstFmt;
          FC.cbwfx = sizeof (DstFmt);
          FC.pszTitle = " ";
          FC.fdwEnum = ACM_FORMATENUMF_CONVERT;
          FC.pwfxEnum = &SrcFmt;

          acmFormatChoose (&FC);

          break;

        }





        //
        //   /
        // ===============================
        //

        case IDC_StartStop: {

          //
          //     
          //

          EnableWindow (GetDlgItem (DlgWin, IDC_StartStop), 0);

          if (!(Flags & SF_Running)) { // 

            int Success;

            InBuffers = 0;

            StartTime = timeGetTime ();

            timeBeginPeriod (1); //   - 1 


            ReadAllParams ();   //  


            //
            //   
            //

            SetPriorityClass (GetCurrentProcess (), HIGH_PRIORITY_CLASS);


            //
            //   
            //

            WorkerThreadHandle = CreateThread (
              NULL,
              0,
              WorkerThreadProc,
              NULL,
              0,
              &WorkerThreadId
            );


            //
            //    
            //

            Success = OpenDevices ();

            if (Success) {

              if (waveInStart (In) == MMSYSERR_NOERROR) {

                //
                //  
                //  


                //
                //   
                //

                EnableControls (
                  FALSE,
                  IDC_WaveIn,
                  IDC_SampleRate,
                  IDC_BitsPerSample,
                  IDC_Mono,
                  IDC_Stereo,
                  IDC_FileName,
                  IDC_FormatChoose,
                  0
                );

                
                //
                //  
                //
                
                DlgMsg (IDC_ConvertedSamples, WM_SETTEXT, 0, (LPARAM)"");

                
                //
                //    
                //

                ShowWindow (
                  GetDlgItem (DlgWin, IDC_ConvertedSamples),
                  SW_SHOW
                );

                DlgMsg (IDC_StartStop, WM_SETTEXT, 0, (LPARAM)"");

                Flags |= SF_Running;

              } else {

                Cleanup ();
                CloseDevices ();
                Error ("  ");

              }

            } else {

              Cleanup ();

            }

          } else { // 

            StopDevices ();

            timeEndPeriod (1);  //   

          }

          if (!(Flags & SF_StopReq)) {

            //
            //     -  
            //
                
            EnableWindow (GetDlgItem (DlgWin, IDC_StartStop), TRUE);

          }

          break;
        
        }

      }

      break;

    }





    //
    //   
    // ===========================
    //

    case WMU_StopCompleted: {
    
      timeEndPeriod (1);        //   

      //
      //      
      //

      CloseHandle (WorkerThreadHandle);

      WorkerThreadId = 0;
      WorkerThreadHandle = NULL;

      CloseDevices ();

      Cleanup ();               //  


      //
      //      
      //

      SetPriorityClass (GetCurrentProcess (), DefPrioClass);

      Flags &= ~(SF_Running | SF_StopReq);


      //
      //  
      //

      ShowWindow (
        GetDlgItem (DlgWin, IDC_ConvertedSamples),
        SW_HIDE
      );


      //
      //   
      //

      EnableControls (
        TRUE,
        IDC_WaveIn,
        IDC_SampleRate,
        IDC_BitsPerSample,
        IDC_Mono,
        IDC_Stereo,
        IDC_FileName,
        IDC_FormatChoose,
        0
      );


      //
      //       
      //

      DlgMsg (IDC_StartStop, WM_SETTEXT, 0, (LPARAM)"");

      EnableWindow (GetDlgItem (DlgWin, IDC_StartStop), 1);


      break;

    }  





  }

  return FALSE;

  UNREF (lp);

}
      

//
//   Windows
// ========================
//

int WINAPI WinMain (
  HINSTANCE Instance,
  HINSTANCE PrevInstance,
  LPSTR Cmd,
  int CmdShow
) {

  int Result;
  

  //
  //     
  //

  InitCommonControls ();


  GlobalInst = Instance;


  //
  //   
  //

  Result = DialogBox (
    Instance, 
    MAKEINTRESOURCE (IDD_RptDialog),
    HWND_DESKTOP,
    DialogProc
  );


  return Result;

  UNREF (PrevInstance);
  UNREF (Cmd);
  UNREF (CmdShow);

}
